<?php
class SPEClass{

    private static $instance;
    private function __construct() { } 
    private function __clone(){} 
 
    public static function getInstance ()
    {
        if (self::$instance === null) {
            self::$instance = new SPEClass();
        }
        return self::$instance;
 
        return (self::$instance === null) ? self::$instance = new SPEClass() : self::$instance;
    }
    
    public function editHeader(){
        //hide for modification time
        ?>
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/edit.css" />
        <?php
    }
    
    public function editExtras($specialName){
        $settings = $this->loadSettings($specialName);

        if (empty($settings))
            return;
            
        $pageData = @$settings['pageData'];
        $fieldsData = @$settings['fieldsData'];

        include('editScripts.php'); //include all js 
    }  

    //php security check for required fields
    public function editSaveSecurityCheck(){
        $settings = $this->loadSettings($_POST['post-special']);
        
        if (empty($settings))
            return;
            
        $pattern = '/\s|<br\s*?\/>/mi'; //trim pattern
              
        if ( $settings['pageData']['content-required'] ){
            $content =  @$_POST['post-content'];
            $content = preg_replace($pattern, '', $content); //same pattern as in js
            
            if ($content == '')
                die('SpecialPagesExtras "content-required" security!');
        }
        
        for ($i = 0; $i < count($settings['fieldsData']); $i++) {
            $fData = $settings['fieldsData'][$i];
            
            if (!$fData['required']) //not required
                continue;

            $data = @$_POST['post-sp-'.$fData['name']];
            
            $data = preg_replace($pattern, '', $data); //same pattern as in js

            if ($data === '')
                die('SpecialPagesExtras "'.$fData['name'].'" field required security!');
        }
        
        
        
    }    
 
    
    
    public function confHeader(){
        ?>
            <link rel="stylesheet" href="../plugins/SpecialPagesExtras/css/configure.css" />
        <?php
    }
   
    //work after all scripts
    public function confFooter(){

        if (!isset($_GET['copy'])) //copying old, load copy source settings
            $pageName = @$_GET['edit'] ? @$_GET['edit'] : $_POST['post-name']; //might be new one or eiditng old one
        else
            $pageName = @$_GET['copy'];
            
        $settings = $this->loadSettings($pageName); 
        
        $pageData = @$settings['pageData'];
        $fieldsData = @$settings['fieldsData'];
        
        include('confScripts.php'); //include all js 
        include('confDialogs.html'); //include dialogs html  
    }
    
    //save settings
    public function confSave(){        
        $fieldsData = array();
    
        for ($i=0; isset($_POST['cf_'.$i.'_name']); $i++) {
            $a = array(
                'name' => $_POST['cf_'.$i.'_name'],
                //supress errors, no javascript set empty vars
                'required' => @$_POST['spe_field-'.$i.'-required'] ? 1 : '',
                'description' => @$_POST['spe_field-'.$i.'-description']
            );

            //store extra params for special types
            switch ($_POST['cf_'.$i.'_type']) {
                case 'image':{
                    $a['thumbnail'] = @$_POST['spe_field-'.$i.'-thumbnail'] ? 1 : '';
                    break;
                }
            }
            
            $fieldsData[] = $a; //add to array
        }

        array_pop($fieldsData); // remove the last hidden line
        
        $this->_confWrite($fieldsData);
        
    }
    
    public function confUndo(){
        $name = preg_match('/^[A-Za-z0-9-]+$/', @$_GET['edit']) ? $_GET['edit'] : null;
        $newname = @$_GET['new'];
    
        //supress errors, no extra data
        @unlink(GSDATAOTHERPATH.'i18n_special-' . $newname . '-extras.xml'); //delete old
        @copy(GSBACKUPSPATH.'other/i18n_special-' . $name . '-extras.xml', GSDATAOTHERPATH.'i18n_special-' . $name . '-extras.xml');
    }
    
    
    public function confDelete(){
        $name = $_GET['delete']; 
         //supress errors, no extra data
        @copy(GSDATAOTHERPATH.'i18n_special-' . $name . '-extras.xml', GSBACKUPSPATH.'other/i18n_special-' . $name . '-extras.xml');
        @unlink(GSDATAOTHERPATH . 'i18n_special-' . $name . '-extras.xml');
    }
    
    public function loadSettings($pageName){
        $ret = array();
    
        $xml = getXML(GSDATAOTHERPATH.'i18n_special-' . $pageName . '-extras.xml');       
     
        //parse data from settings
        if ($xml){
            foreach ($xml->page->children() as $pageSetting)
            {
                $name = $pageSetting->getName();
                $ret['pageData'][$name] = (string)$pageSetting;
            }     

            foreach ($xml->fields->children() as $field)
            {      
                $fieldsData[] = array();
            
                foreach ($field->children() as $fieldSetting)
                {               
                    $name = $fieldSetting->getName();
                    $ret['fieldsData'][ count($fieldsData) - 1 ][$name] = (string)$fieldSetting;
                }
            }
        }
        
        return $ret;
    }

    //writes xml data
    private function _confWrite($fieldsData){    
        $data = @new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><extras></extras>');
        $page = $data->addChild('page');
        
        $page->addChild('title-label-show', isset($_POST['spe_page-title-label-show']) ? 1 : '');
        $page->addChild('title-label')->addCData($_POST['spe_page-title-label']);
        $page->addChild('content-label-show', isset($_POST['spe_page-content-label-show']) ? 1 : '');
        $page->addChild('content-label')->addCData($_POST['spe_page-content-label']);
        $page->addChild('content-required', isset($_POST['spe_page-content-required']) ? 1 : '');
        $page->addChild('tags-hide', isset($_POST['spe_page-tags-hide']) ? 1 : '');
        $page->addChild('meta-description-hide', isset($_POST['spe_page-meta-description-hide']) ? 1 : '');
        
        $fields = $data->addChild('fields');
        
        for ($i = 0; $i < count($fieldsData); $i++){
            $f = $fields->addChild('field');
            
            //iterate over params and add to xml
            foreach ($fieldsData[$i] as $key => $value){
                $f->addChild($key)->addCData($value);
            }

        }
        
        //store backup
        $oldName = @$_GET['edit'];
        
        if ($oldName && file_exists(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml')) {
            @copy(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml', GSBACKUPSPATH . 'other/i18n_special-' . $oldName . '-extras.xml'); //create copy
            @unlink(GSDATAOTHERPATH . 'i18n_special-' . $oldName . '-extras.xml'); //delete old
        }
        
        //name must be with minus char not underscore to not be identified as special page type file
        XMLsave($data, GSDATAOTHERPATH . 'i18n_special-' . $_POST['post-name'] . '-extras.xml');
         
    }
    
    

}