<script>
$(document).ready(function() {

    //generated by php
    var fieldsData = <?php echo json_encode($fieldsData) ?>;
    
    //generated by php
    var pageData =  <?php echo json_encode($pageData) ?>;
   
    var $specialpagesForm =  $('#specialpagesForm');
        $tabFields = $('#tab-fields'),
        $editFields = $('#editfields'),
        $pageDialog = $('#spe_page-dialog'),
        $fieldDialog = $('#spe_field-dialog'),
        $dialogs = $pageDialog.add($fieldDialog);
        
    //parameters for field types
    var params = {
                    def : ['required', 'description'], //default for all fields
                    image : ['thumbnail']
                };
                    
        
    $specialpagesForm.find('td[colspan="5"]').attr('colspan', $editFields.find('tbody tr:first td').length - 1); //fix sp buggy colspan
    
    //add page dialog to form
    $specialpagesForm.prepend($pageDialog); 
    
    //add page dialog open button
    $tabFields.find('#post-defaultcontent').closest('p')
        .prepend('<button type="button" id="spe_page-button" class="spe_field_button spe_page" ><?php i18n('SpecialPagesExtras/PAGES_EXTRAS'); ?></button>');//
   
    //add buttons and hidden fields with field params on startup
    $editFields.find('td.delete').each(function(index){
        var $td = $(this);
            $tr = $td.closest('tr');
            type = $tr.find('select[name$="_type"]').val();
              
        var allParams = getParamsForType(type);
        $td.append(generateHiddenInputs(allParams));
        
        //add button to open dialog
        $td.prepend('<button type="button" class="spe_field_button" title="<?php i18n('SpecialPagesExtras/FIELD_EXTRAS'); ?>" ><img src="../plugins/SpecialPagesExtras/img/configure.png"/> </button>');
    });
    
    fillPageForm(pageData);                
    fillFieldsInputs(fieldsData);
    
    $('#maincontent').show();//show hidden by css
    
    //----------------------------------------- HANDLERS and functions ------------------------
     
    //update hidden inputs on field type change
    $editFields.on('change', 'tbody tr select[name$="_type"]', function(event){
        var $tr = $(this).closest('tr'),
            $td = $tr.find('td.delete'),
            newType = $(this).val(),
            $hiddenInputs = $td.find('input[type="hidden"]'),
            typeParams = getParamsForType(newType, true);
        
        //remove not default params hidden inputs
        $hiddenInputs.each(function(){
            var $hInput = $(this),
                name = $hInput.attr('name'),
                param = name.substr(name.lastIndexOf('-') + 1);
                
            //if is default one
            if (params.def.indexOf(param) != -1)
                return; //continue
                
            $hInput.remove();
        });
        
        //add type specific params
        $td.append(generateHiddenInputs(typeParams));
    });
     
    //opens extra field dialog
    $editFields.on('click', 'tbody tr .spe_field_button', function(event){
        event.preventDefault();
        
        var $button = $(this),
            $tr = $button.closest('tr'),
            type = $tr.find('select[name$="_type"]').val();
            $dialog = $fieldDialog,
            $form = $dialog.find('form');
            
        resetForm($form);
        prepareForm(type);
        
        //store edited field index
        $dialog.data( 'spe-edited-index', $tr.index() );

        //add to header field name
        $dialog.find('h3 span').text( $tr.find('input[name$="_name"]').val() );
                           
        //fill field dialog inputs form hidden inputs
        $fieldDialog.find('input,textarea').each(function(){
            var $input = $(this),
                name = $input.attr('name'),
                param = name.substr(name.lastIndexOf('-')),
                val = $button.siblings('input[name$="'+ param +'"]').val();
            
            if ( $input.is('[type="checkbox"]') && val ){
                $input.attr('checked', true);
            }    
            else if ( $input.is('textarea') && val ){
                $input.val( val.replace(/<br\/>/g, "\n") ); 
            }
            else{
                $input.val( val ); 
            }
        });
        
        $dialog.dialog();
        $dialog.css('position', 'fixed'); //fix
    });
    
                    
    //page confs dialog, part of form
    $('#spe_page-button').click(function(event){
        event.preventDefault();
        $pageDialog.dialog();
        $pageDialog.css('position', 'fixed'); //fix
    });
    
    //dialog ok
    $dialogs.find('.valueok').click(function(event){
        event.preventDefault();
                  
        var $dialog = $(this).parents('.spe_dialog');
        
        if ( !$dialog.is($pageDialog) ){ //field  dialog
            //fill hidden fields from dialog inputs only visible = for type
            $fieldDialog.find('tr:visible input,textarea').each(function(){
                var $input = $(this),
                    name = $input.attr('name'),
                    param = 'spe_field-x-' + name.substr(name.lastIndexOf('-') + 1),
                    $hInput = $editFields.find('tbody tr:eq('+ $fieldDialog.data('spe-edited-index') +') td.delete')
                        .find('input[type="hidden"][name="'+ param +'"]');
                
                if ( $input.is('[type="checkbox"]')){
                    $hInput.val($input.attr('checked'));
                }      
                else if ( $input.is('textarea')){
                   $hInput.val( $input.val().replace(/\n/g, '<br/>') ); 
                }
                else{
                    $hInput.val( $input.val() ); 
                }
            });
        }
        
        $dialog.dialog('close');
    }); 
    
    //dialog cancel
    $dialogs.find('.valuecancel').click(function(event){
        event.preventDefault();
        var $dialog = $(this).parents('.spe_dialog');
        $dialog.dialog('close');
    });
    
     //create  numbers for hidden inputs before submit
    $specialpagesForm.submit(function(){                  
        $editFields.find('td.delete input[name^="spe_field-x"]').each(function(index){
            var $input = $(this),
                rowIdx = $input.closest('tr').index();
        
            $input.attr('name', $input.attr('name').replace('-x-', '-'+rowIdx+'-')); 
        });
    });
    
    
    function resetForm ($form){
        $form.find('textarea,input,select').val('').removeAttr('checked');//reset values
        $form.find('tr[data-type]').hide(); //hide all fields non standard
    };
    
    //prepares by showing fields required by type
    function prepareForm(forType){
        $form.find('tr[data-type="'+forType+'"]').show();
    };
    
    //return array of params for type, with defaults or only for type
    function getParamsForType (type, withoutDefaults){
        var p = withoutDefaults ? [] : params.def.slice(0); //clone

        if (typeof(params[type]) !== 'undefined'){
            return p.concat(params[type]);
        }
        else{
            return p;
        }
    };
    
    //generates hidden inputs for specified params
    function generateHiddenInputs(params){
        var s = '';        
        for (var i = 0; i < params.length; i++){ 
            s += '<input name="spe_field-x-'+ params[i] +'" type="hidden" />'
        }
        return s;
    }
    
    function fillPageForm(pageData){
        if (!pageData)
            return;
        
        $.each( pageData, function( key, value ) {
            var $input = $pageDialog.find('input[name$="'+ key +'"]');
            
            if ($input.length){

                if ($input.is('[type="checkbox"]') && value){
                    $input.attr('checked', true);
                }
                else{
                    $input.val(value);
                }
            }
        });

    }         

    
    function fillFieldsInputs(fieldsData){
        if (!fieldsData)
            return;
    
        $.each( fieldsData, function( index, value ) {
            var $nameInput = $editFields.find('tbody tr td input[name$="_name"][value="'+ value.name +'"]');
                                           
            if (!$nameInput.length) //not found field
                return;
                
            var $deleteTd = $nameInput.closest('td').siblings('td.delete');

            //fill all field hidden inputs
            $deleteTd.find('input[type="hidden"]').each(function(){
                var $input = $(this),
                    name = $input.attr('name'),
                    paramName = name.substr(name.lastIndexOf('-') + 1);
                    
                if (typeof(value[paramName]) !== 'undefined'){
                    $input.val(value[paramName]);
                }
            });
        });
    }

}); 
</script>