<?php
include('../../../admin/inc/common.php');
$loggedin = cookie_check();
if (!$loggedin) die('not logged!');


$maxWidth = 300;
$maxHeight = 200;

$browser_cache = 3600; //one hour

$cacheDir = GSDATAOTHERPATH . 'SpecialPagesExtras/thumbs/';

$errorNoImage = @$_GET['no'];
$errorNotFound = @$_GET['nf'];
$errorNotImage = @$_GET['ni'];

$requested_path = trullyremoverelativepath( @$_GET['img'] ); //requested folder form uploads dir
if (empty($requested_path)){
    sendError($errorNoImage); //empty image
}

$host = $_SERVER['SERVER_NAME'] . ($_SERVER['SERVER_PORT'] != '80' ? ':'.$_SERVER['SERVER_PORT'] : '');
$pathParts = pathinfo($_SERVER['PHP_SELF']);
$subDir = htmlentities(str_replace('plugins/SpecialPagesExtras/thumb', '', $pathParts['dirname']), ENT_QUOTES);
$port = ($p=$_SERVER['SERVER_PORT'])!='80'&&$p!='443'?':'.$p:'';
$siteHost = htmlentities(http_protocol()."://". $host . $port, ENT_QUOTES);


//delete site host from image url
if ( substr($requested_path, 0, strlen($siteHost) ) == $siteHost) {
    $requested_path = substr($requested_path, strlen($siteHost));
}

//delete site dir from url (may be root relative path)
if ( substr($requested_path, 0, strlen($subDir) ) == $subDir) {
    $requested_path = substr($requested_path, strlen($subDir));
}

//if it begins with / delete it (root relative path) (mainly for windows)
if (substr($requested_path, 0, 1) == '/')
    $requested_path = substr($requested_path, 1);
    

$requested_file = basename($requested_path);
$requested_path = substr($requested_path, 0, -strlen($requested_file)); //delete file name from path

$source_file = GSROOTPATH.$requested_path.$requested_file;

// check if the file exists at all
if (!$requested_file || !file_exists($source_file)) {
    sendError($errorNotFound);
}

/* check that PHP has the GD library available to use for image re-sizing */
if (!extension_loaded('gd')) { // it's not loaded
  if (!function_exists('dl') || !dl('gd.so')) { // and we can't load it either
    // no GD available, so deliver the image straight up
    sendError('GD not available.');
  }
}

/* whew might the cache file be? */
$cached_thumb = $cacheDir.$requested_path.$requested_file;

if (file_exists($cached_thumb)) { // it exists cached at that size
  //  cache watching is enabled, compare cache and source modified dates to ensure the cache isn't stale
  $cached_thumb = refreshCache($source_file, $cached_thumb, $maxWidth, $maxHeight);
  sendImage($cached_thumb, $browser_cache);
}

/* It exists as a source file, and it doesn't exist cached - lets make one: */
$file = generateImage($source_file, $cached_thumb, $maxWidth, $maxHeight);
sendImage($file, $browser_cache);

/* helper function: Create and send an image with an error message. */
function sendError($message) {
  global $maxWidth, $maxHeight;

  $im = ImageCreateTrueColor($maxWidth, $maxHeight);
  imagefill( $im, 0, 0, ImageColorAllocate($im, 255, 255, 255));

  imageCenterString ($im, 2, $message, ImageColorAllocate($im, 0, 0, 0));

  header("Cache-Control: no-store");
  header('Expires: '.gmdate('D, d M Y H:i:s', time()-1000).' GMT');
  header('Content-Type: image/jpeg');
  ImageJpeg($im);
  ImageDestroy($im);
  exit();
}


/* helper function: Send headers and returns an image. */
function sendImage($filename, $browser_cache) {
  $extension = strtolower(pathinfo($filename, PATHINFO_EXTENSION));
  if (in_array($extension, array('png', 'gif', 'jpeg'))) {
    header("Content-Type: image/".$extension);
  } else {
    header("Content-Type: image/jpeg");
  }

  header("Cache-Control: private, max-age=".$browser_cache);
  header('Expires: '.gmdate('D, d M Y H:i:s', time()+$browser_cache).' GMT');
  header('Content-Length: '.filesize($filename));
  readfile($filename);
  exit();
}

/* generates the given cache file for the given source file with the given resolution and by height or width */
function generateImage($source_file, $cache_file, $maxWidth, $maxHeight) {
  global $errorNotImage;
    
  $extension = strtolower(pathinfo($source_file, PATHINFO_EXTENSION));

  // Check the image dimensions
  $dimensions   = GetImageSize($source_file);
  $width        = $dimensions[0];
  $height       = $dimensions[1];
  
  if (!$dimensions){
    sendError($errorNotImage);
  }

    // So then if the image is wider rather than taller, set the width and figure out the height
    if ( ($width / $height ) > ($maxWidth / $maxHeight)) {
        $newWidth = $maxWidth;
        $newHeight = ($maxWidth * $height) / $width;
    }
    // And if the image is taller rather than wider, then set the height and figure out the width
    elseif (($width / $height) < ($maxWidth / $maxHeight)) {
        $newWidth = ($maxHeight * $width)/ $height;
        $newHeight = $maxHeight;
    }
    // And because it is entirely possible that the image could be the exact same size/aspect ratio of the desired area, so we have that covered as well
    else{
        $newWidth = $maxWidth;
        $newHeight = $maxHeight;
    }

    //generating thumbnail not needed, image is smaller than thumb
    if ($width <= $maxWidth && $height <= $maxHeight)
        return $source_file;
     
  $dst = ImageCreateTrueColor($newWidth, $newHeight); // re-sized image

  switch ($extension) {
    case 'png':
      $src = @ImageCreateFromPng($source_file); // original image
    break;
    case 'gif':
      $src = @ImageCreateFromGif($source_file); // original image
    break;
    default:
      $src = @ImageCreateFromJpeg($source_file); // original image
      ImageInterlace($dst, true); // Enable interlancing (progressive JPG, smaller size file)
    break;
  }
  

  if($extension=='png'){
    imagealphablending($dst, false);
    imagesavealpha($dst,true);
    $transparent = imagecolorallocatealpha($dst, 255, 255, 255, 127);
    imagefilledrectangle($dst, 0, 0, $newWidth, $newHeight, $transparent);
  }
  
  ImageCopyResampled($dst, $src, 0, 0, 0, 0, $newWidth, $newHeight, $width, $height); // do the resize in memory
  ImageDestroy($src);

  // sharpen the image
  // NOTE: requires PHP compiled with the bundled version of GD (see http://php.net/manual/en/function.imageconvolution.php)
  if(function_exists('imageconvolution')) {
    $intSharpness = findSharp($width, $newWidth);
    $arrMatrix = array(
      array(-1, -2, -1),
      array(-2, $intSharpness + 12, -2),
      array(-1, -2, -1)
    );
    imageconvolution($dst, $arrMatrix, $intSharpness, 0);
  }

  $cache_dir = dirname($cache_file);

  // does the directory exist already?
  if (!is_dir($cache_dir)) { 
    if (!mkdir($cache_dir, 0755, true)) {
      // check again if it really doesn't exist to protect against race conditions
      if (!is_dir($cache_dir)) {
        // uh-oh, failed to make that directory
        ImageDestroy($dst);
        sendError('Failed to create cache dir.');
      }
    }
  }

  if (!is_writable($cache_dir)) {
    sendError('Cache dir is not writable');
  }

  // save the new file in the appropriate path, and send a version to the browser
  switch ($extension) {
    case 'png':
      $gotSaved = ImagePng($dst, $cache_file);
    break;
    case 'gif':
      $gotSaved = ImageGif($dst, $cache_file);
    break;
    default:
      $gotSaved = ImageJpeg($dst, $cache_file, 92);
    break;
  }
  ImageDestroy($dst);

  if (!$gotSaved && !file_exists($cache_file)) {
    sendError('Failed to create thumb');
  }

  return $cache_file;
}

/* refreshes the cached image if it's outdated */
function refreshCache($source_file, $cache_file, $maxWidth, $maxHeight) {
  if (file_exists($cache_file)) {
    // not modified
    if (filemtime($cache_file) >= filemtime($source_file)) {
      return $cache_file;
    }

    // modified, clear it
    unlink($cache_file);
  }
  return generateImage($source_file, $cache_file, $maxWidth, $maxHeight);
}

/* sharpen images function */
function findSharp($intOrig, $intFinal) {
  $intFinal = $intFinal * (750.0 / $intOrig);
  $intA     = 80; //changed from 52
  $intB     = -0.27810650887573124;
  $intC     = .00047337278106508946;
  $intRes   = $intA + $intB * $intFinal + $intC * $intFinal * $intFinal;
  return max(round($intRes), 0);
}

function imageCenterString(&$img, $font, $text, $color)
{
     if($font < 0 || $font > 5){ $font = 0; }
     $num = array(array(4.6, 6),
                  array(4.6, 6),
                  array(5.6, 12),
                  array(6.5, 12),
                  array(7.6, 16),
                  array(8.5, 16));
     $width = ceil(strlen($text) * $num[$font][0]);
     $x     = imagesx($img) - $width - 8;
     $y     = Imagesy($img) - ($num[$font][1] + 2);
     imagestring($img, $font, $x/2, $y/2, $text, $color);
}


//removes relative path from path
function trullyremoverelativepath($file) {
    return preg_replace ('/\.\.?[\\\\\/]/', '' , $file);
}